require "omniauth-oauth2"
require "multi_json"

module OmniAuth
  module Strategies
    class WonderfulUnion < OmniAuth::Strategies::OAuth2
      SITE_URL = "https://my.wun.io".freeze

      option :name, "wonderful_union"

      option :client_options,
             site: SITE_URL,
             authorize_url: "#{SITE_URL}/oauth/authorize",
             token_url: "#{SITE_URL}/oauth/token"

      def authorize_params
        super.tap do |params|
          %w(scope client_options).each do |v|
            params[v.to_sym] = request.params[v] if request.params[v]
          end
        end
      end

      uid { raw_info["id"] }

      info do
        { email: raw_info["email"] }
      end

      def raw_info
        @raw_info ||= access_token.get("/api/v1/me.json").parsed
      end

      def callback_url
        full_host + script_name + callback_path
      end
    end
  end
end
